import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.nio.charset.*;
import java.nio.file.*;
import java.util.*;
import java.util.prefs.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;

import javax.swing.text.Highlighter.HighlightPainter;

//-------------------------------------
public class BinDump extends JFrame implements WindowListener {

public class BytA extends ArrayList<Byte> {}

static BinDump   mf;
static String fto;

JButton       sbar;
JScrollPane   spta;
JTextArea     txta;

BytA          fc;
File          fil;
Font          taf, uif;
int           maxx, maxy, winx, winy;
int           tafs, uifs, wxp, wyp;
String        stxt, tafn, uifn, wdir;

static final int    PERLIN  = 8;
static final int    TAFSIZ  = 20;
static final int    UIFSIZ  = 32;
static final int    WXP     = 50;
static final int    WYP     = 90;
static final String APPNAM  = "BinDump";
static final String DEFDIR  = "C:\\";
static final String DIRKEY  = "WRKDIR";
static final String TAFNLIT = "TAFN";
static final String TAFSLIT = "TAFS";
static final String UIFNLIT = "UIFN";
static final String UIFSLIT = "UIFS";
static final String WXPLIT  = "WXP";
static final String WYPLIT  = "WYP";

//-------------------------------------
class AFile implements ActionListener {
public void actionPerformed(ActionEvent fae) {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Open");
  mi.setMnemonic('O');
  mi.addActionListener(new AFileOpen());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("saveAs");
  mi.setMnemonic('A');
  mi.addActionListener(new AFileSaveAs());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class AFileOpen implements ActionListener {
public void actionPerformed(ActionEvent foae) {
int             fsts;
JFileChooser    fc;
String          fn;
  fc = new JFileChooser(wdir);
  fc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = fc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    fil = fc.getSelectedFile();
    wdir = fil.getPath();
    SetPreferences();
    fn = fil.getName();
    mf.setTitle(fn);
    OpenFile(fil);
  }
}}

//-------------------------------------
class AFileSaveAs implements ActionListener {
public void actionPerformed(ActionEvent fsaae) {
File  f;
  f = GetFileToSave();
  if (f!=null) SaveFile(f);
}}

//-------------------------------------
class AMinimize implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  mf.setState(Frame.ICONIFIED);
}}

//-------------------------------------
class AQuit implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  System.exit(0);
}}

//-------------------------------------
public BinDump(String[] args) {
Dimension dim;
Toolkit   tk;
  tk = Toolkit.getDefaultToolkit();
  dim = tk.getScreenSize();
  maxx = dim.width;
  maxy = dim.height;
  if (args.length>0) fto = args[0];
  else fto = "";
}

//-------------------------------------
class CBButton implements ActionListener {
public void actionPerformed(ActionEvent cbae) {
  PopupMain();
}}

//-------------------------------------
class CBKey extends KeyAdapter {
public void keyPressed(KeyEvent ke) {
int   kc;
  kc = ke.getKeyCode();
  if (kc == KeyEvent.VK_F1) PopupMain();
}}

//-------------------------------------
class CBMouse extends MouseAdapter {
public void mouseClicked(MouseEvent me) {
   PopupMain();
}}

//-------------------------------------
class CBResize extends ComponentAdapter {
public void componentResized(ComponentEvent ce) {
Insets  is;
  winx = getWidth();
  winy = getHeight();
  is = mf.getInsets();
  winx -= (is.left+is.right);
  winy -= (is.top+is.bottom);
}}

//-------------------------------------
void FormatDump() {
int    bi, i, nbyt, nlin, todo;
String s;
  s = "";
  bi = 0;
  nbyt = fc.size();
  nlin = nbyt/PERLIN;
  if (nbyt%PERLIN>0) nlin++;
  for (i=0; i<nlin; i++) {
    todo = nbyt - bi;
    if (todo>PERLIN) todo = PERLIN;
    s += FormatLine(bi, todo);
    s += "\n";
    bi += todo;
  }
  txta.setText(s);
  txta.setCaretPosition(0);
  txta.requestFocusInWindow();
}

//-------------------------------------
String FormatLine(int bi, int todo) {
byte   byt;
int    i;
String s;
  s = String.format("%08X ", bi);
  for (i=0; i<todo; i++) {
    byt = fc.get(bi+i);
    s += String.format("%02X ", byt);
  }
  for (i=i; i<PERLIN; i++) s += "   ";
  s += " ";
  for (i=0; i<todo; i++) {
    byt = fc.get(bi+i);
    if (byt<0x20) s+= String.format("%c", ' ');
    else s+= String.format("%c", byt);
  }
  return(s);
}

//-------------------------------------
File GetFileToSave() {
File          f;
int           fsts;
JFileChooser  fc;
  f = null;
  fc = new JFileChooser(wdir);
  fc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = fc.showSaveDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    f = fc.getSelectedFile();
    wdir = f.getPath();
  }
  return(f);
}

//-------------------------------------
void Initlz() {
  InitlzVars();
  ReadIniFile();
  ReadPreferences();
  InitlzUI();
  LayoutUI();
}

//-------------------------------------
void InitlzUI() {
  winx = (wxp*maxx)/100;
  winy = (wyp*maxy)/100;
  uif = new Font(uifn, Font.BOLD, uifs);
  Util.PutUIManFonts(uif);
  taf = new Font(tafn, Font.PLAIN, tafs);
  sbar = new JButton(stxt);
  sbar.setFont(uif);
  sbar.addActionListener(new CBButton());
  sbar.addKeyListener(new CBKey());
  sbar.setBackground(new Color(0.5f, 0.1f, 0.1f));
  sbar.setForeground(new Color(1.0f, 1.0f, 0.1f));
  InitlzUITextArea();
  InitlzUIResources();
}

//-------------------------------------
void InitlzUIResources() {
Image       iimg;
Toolkit     tk;
URL         iurl;
  tk = Toolkit.getDefaultToolkit();
  iurl = mf.getClass().getResource("/BinDump.png");
  iimg = tk.createImage(iurl);
  setIconImage(iimg);
}

//-------------------------------------
void InitlzUITextArea() {
Dimension   dim;
JScrollBar  jsb;
  txta = new JTextArea();
  txta.addKeyListener(new CBKey());
  txta.setFont(taf);
  txta.setBackground(new Color(0xFFFFFF));
  txta.setLineWrap(true);
  txta.setWrapStyleWord(true);
  txta.setTabSize(2);
  spta = new JScrollPane(txta);
  spta.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
  spta.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
  jsb = spta.getVerticalScrollBar();
  dim = jsb.getPreferredSize();
  dim.width *=2;
  jsb.setPreferredSize(dim);
}

//-------------------------------------
void InitlzVars() {
  uifn = Font.SERIF;
  uifs = UIFSIZ;
  tafn = Font.MONOSPACED;
  tafs = TAFSIZ;
  wxp = WXP;
  wyp = WYP;
  wdir = DEFDIR;
  stxt = "Click Here";
  fc = new BytA();
}

//-------------------------------------
void LayoutUI() {
  addWindowListener(this);
  mf.addKeyListener(new CBKey());
  mf.addComponentListener(new CBResize());
  mf.setLocation((maxx-winx)/2, 0);
  mf.setSize(winx, winy);
  mf.getContentPane().add(sbar, BorderLayout.NORTH);
  mf.getContentPane().add(spta, BorderLayout.CENTER);
  mf.setTitle("BinDump");
  mf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  mf.setVisible(true);
}

//-------------------------------------
public static void main(String[] args) {
  mf = new BinDump(args);
  mf.Initlz();
}

//-------------------------------------
void OpenFile(File f) {
byte[]          bufr;
byte            byt;
int             i, j, nbyt, read;
FileInputStream fis;
  fc.clear();
  bufr = new byte[0x1000];
  try {
    fis = new FileInputStream(fil);
    do {
      read = fis.read(bufr, 0, 0x1000);
      if (read!=-1) for (i=0; i<read; i++) fc.add(bufr[i]);
    } while(read!=-1);
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
  FormatDump();
}

//-------------------------------------
void PopupMain() {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("File");
  mi.setMnemonic('F');
  mi.addActionListener(new AFile());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Minimize");
  mi.setMnemonic('M');
  mi.addActionListener(new AMinimize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Quit");
  mi.setMnemonic('Q');
  mi.addActionListener(new AQuit());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}

//-------------------------------------
void ReadIniFile() {
BufferedReader  br;
Charset         cs;
File            inif;
Path            ifp;
String          jini, line, nam, val;
String[]        sa;
  jini = System.getenv("JINI")+"BinDump.ini";
  inif = new File(jini);
  if (!inif.exists()) {
    stxt = "no ini file";
    return;
  }
  ifp = inif.toPath();
  cs = Charset.forName("US-ASCII");
  try {
    br = Files.newBufferedReader(ifp, cs);
    while ((line = br.readLine()) != null) {
      sa = line.split("=");
      if (sa.length==2) {
        nam = sa[0];
        val = sa[1];
        if (nam.compareTo(UIFNLIT)==0) uifn = val;
        if (nam.compareTo(UIFSLIT)==0) uifs = Integer.parseInt(val);
        if (nam.compareTo(TAFNLIT)==0) tafn = val;
        if (nam.compareTo(TAFSLIT)==0) tafs = Integer.parseInt(val);
        if (nam.compareTo(WXPLIT)==0) wxp = Integer.parseInt(val);
        if (nam.compareTo(WYPLIT)==0) wyp = Integer.parseInt(val);
      }
    }
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//-------------------------------------
void ReadPreferences() {
Preferences p;
  try {
    p = Preferences.userRoot().node(getClass().getName());
    wdir = p.get(DIRKEY, DEFDIR);
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//-------------------------------------
void SaveFile(File f) {
BufferedWriter  bw;
FileWriter      fw;
String          txt;
  txt = txta.getText();
  Util.SaveTextFile(f, txt, mf);
}

//-------------------------------------
void SetPreferences() {
Preferences p;
  p = Preferences.userRoot().node(getClass().getName());
  p.put(DIRKEY, wdir);
}

//-------------------------------------
public void windowActivated(WindowEvent e) {}
public void windowDeactivated(WindowEvent e) {}
public void windowDeiconified(WindowEvent e) {}
public void windowIconified(WindowEvent e) {}
public void windowClosing(WindowEvent e) {}
public void windowClosed(WindowEvent e) {}
public void windowOpened(WindowEvent e) { 
  if (fto.length()>0) {
    fil = new File(fto);
    wdir = fil.getPath();
    SetPreferences();
    OpenFile(fil); 
  }
}

//-------------------------------------
}
